Index: src/molecule.hpp
===================================================================
--- src/molecule.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -7,16 +7,9 @@
 #define MOLECULES_HPP_
 
-using namespace std;
-
 /*********************************************** includes ***********************************/
 
-// GSL headers
-#include <gsl/gsl_eigen.h>
-#include <gsl/gsl_heapsort.h>
-#include <gsl/gsl_linalg.h>
-#include <gsl/gsl_matrix.h>
-#include <gsl/gsl_multimin.h>
-#include <gsl/gsl_vector.h>
-#include <gsl/gsl_randist.h>
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 //// STL headers
@@ -31,9 +24,10 @@
 #include "types.hpp"
 #include "graph.hpp"
-#include "stackclass.hpp"
-#include "tesselation.hpp"
+#include "PointCloud.hpp"
 #include "Patterns/Observer.hpp"
 #include "Patterns/ObservedIterator.hpp"
 #include "Patterns/Cacheable.hpp"
+#include "Formula.hpp"
+#include "AtomSet.hpp"
 
 #include "Descriptors/MoleculeDescriptor_impl.hpp"
@@ -53,4 +47,6 @@
 class periodentafel;
 class Vector;
+class Shape;
+template <class> class StackClass;
 
 /******************************** Some definitions for easier reading **********************************/
@@ -89,5 +85,5 @@
 
   public:
-    typedef std::list<atom*> atomSet;
+    typedef ATOMSET(std::list) atomSet;
     typedef std::set<atomId_t> atomIdSet;
     typedef ObservedIterator<atomSet> iterator;
@@ -103,6 +99,4 @@
     //int AtomCount;          //!< number of atoms, brought up-to-date by CountAtoms()
     int BondCount;          //!< number of atoms, brought up-to-date by CountBonds()
-    int ElementCount;       //!< how many unique elements are therein
-    int ElementsInMolecule[MAX_ELEMENTS]; //!< list whether element (sorted by atomic number) is alread present or not
     mutable int NoNonHydrogen;  //!< number of non-hydrogen atoms in molecule
     mutable int NoNonBonds;     //!< number of non-hydrogen bonds in molecule
@@ -110,10 +104,10 @@
     double BondDistance;  //!< typical bond distance used in CreateAdjacencyList() and furtheron
     bool ActiveFlag;    //!< in a MoleculeListClass used to discern active from inactive molecules
-    Vector Center;      //!< Center of molecule in a global box
+    //Vector Center;      //!< Center of molecule in a global box
     int IndexNr;        //!< index of molecule in a MoleculeListClass
     char name[MAXSTRINGSIZE];         //!< arbitrary name
 
   private:
-    Cacheable<string> formula;
+    Formula formula;
     Cacheable<int>    AtomCount;
     moleculeId_t id;
@@ -141,6 +135,11 @@
   void setId(moleculeId_t);
   void setName(const std::string);
-  const std::string getFormula();
-  std::string calcFormula();
+  const Formula &getFormula();
+  unsigned int getElementCount();
+  bool hasElement(const element*) const;
+  bool hasElement(atomicNumber_t) const;
+  bool hasElement(const std::string&) const;
+
+  virtual bool changeId(atomId_t newId);
 
   iterator begin();
@@ -166,16 +165,4 @@
   bool IsEmpty() const ;
   bool IsEnd() const ;
-
-  // templates for allowing global manipulation of all vectors
-  template <typename res> void ActOnAllVectors( res (Vector::*f)() ) const;
-  template <typename res> void ActOnAllVectors( res (Vector::*f)() const) const;
-  template <typename res, typename T> void ActOnAllVectors( res (Vector::*f)(T), T t ) const;
-  template <typename res, typename T> void ActOnAllVectors( res (Vector::*f)(T) const, T t ) const;
-  template <typename res, typename T> void ActOnAllVectors( res (Vector::*f)(T&), T &t ) const;
-  template <typename res, typename T> void ActOnAllVectors( res (Vector::*f)(T&) const, T &t ) const;
-  template <typename res, typename T, typename U> void ActOnAllVectors( res (Vector::*f)(T, U), T t, U u ) const;
-  template <typename res, typename T, typename U> void ActOnAllVectors( res (Vector::*f)(T, U) const, T t, U u ) const;
-  template <typename res, typename T, typename U, typename V> void ActOnAllVectors( res (Vector::*f)(T, U, V), T t, U u, V v) const;
-  template <typename res, typename T, typename U, typename V> void ActOnAllVectors( res (Vector::*f)(T, U, V) const, T t, U u, V v) const;
 
   // templates for allowing global manipulation of molecule with each atom as single argument
@@ -260,5 +247,4 @@
 
   /// Count and change present atoms' coordination.
-  void CountElements();
   bool CenterInBox();
   bool BoundInBox();
@@ -273,5 +259,5 @@
   void Scale(const double ** const factor);
   void DeterminePeriodicCenter(Vector &center);
-  Vector * DetermineCenterOfGravity();
+  Vector * DetermineCenterOfGravity() const;
   Vector * DetermineCenterOfAll() const;
   Vector * DetermineCenterOfBox() const;
@@ -281,5 +267,4 @@
   bool VerletForceIntegration(char *file, config &configuration, const size_t offset);
   void Thermostats(config &configuration, double ActualTemp, int Thermostat);
-  void PrincipalAxisSystem(bool DoRotate);
   double VolumeOfConvexEnvelope(bool IsAngstroem);
 
@@ -316,5 +301,5 @@
 
   molecule *CopyMolecule();
-  molecule* CopyMoleculeFromSubRegion(const Vector offset, const double *parallelepiped) const;
+  molecule* CopyMoleculeFromSubRegion(const Shape&) const;
 
   /// Fragment molecule by two different approaches:
@@ -340,9 +325,8 @@
 
   // Recognize doubly appearing molecules in a list of them
-  int * IsEqualToWithinThreshold(molecule *OtherMolecule, double threshold);
   int * GetFatherSonAtomicMap(molecule *OtherMolecule);
 
   // Output routines.
-  bool Output(ofstream * const output);
+  bool Output(std::ostream * const output);
   bool OutputTrajectories(ofstream * const output);
   void OutputListOfBonds() const;
@@ -384,5 +368,4 @@
   void Enumerate(ostream *out);
   void Output(ofstream *out);
-  void DissectMoleculeIntoConnectedSubgraphs(const periodentafel * const periode, config * const configuration);
   int CountAllAtoms() const;
 
@@ -395,13 +378,4 @@
   void parseXYZIntoMolecule();
   void eraseMolecule();
-
-
-  // merging of molecules
-  bool SimpleMerge(molecule *mol, molecule *srcmol);
-  bool SimpleAdd(molecule *mol, molecule *srcmol);
-  bool SimpleMultiMerge(molecule *mol, int *src, int N);
-  bool SimpleMultiAdd(molecule *mol, int *src, int N);
-  bool ScatterMerge(molecule *mol, int *src, int N);
-  bool EmbedMerge(molecule *mol, molecule *srcmol);
 
   private:
Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule_dynamics.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,11 +17,15 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "info.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/Info.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "parser.hpp"
-#include "Plane.hpp"
+#include "LinearAlgebra/Plane.hpp"
 #include "ThermoStatContainer.hpp"
+
+#include <gsl/gsl_matrix.h>
+#include <gsl/gsl_vector.h>
+#include <gsl/gsl_linalg.h>
 
 /************************************* Functions for class molecule *********************************/
@@ -509,5 +518,5 @@
       Sprinter = mol->AddCopyAtom((*iter));
       for (int n=NDIM;n--;) {
-        Sprinter->x[n] = (*iter)->Trajectory.R.at(startstep)[n] + (PermutationMap[(*iter)->nr]->Trajectory.R.at(endstep)[n] - (*iter)->Trajectory.R.at(startstep)[n])*((double)step/(double)MaxSteps);
+        Sprinter->set(n, (*iter)->Trajectory.R.at(startstep)[n] + (PermutationMap[(*iter)->nr]->Trajectory.R.at(endstep)[n] - (*iter)->Trajectory.R.at(startstep)[n])*((double)step/(double)MaxSteps));
         // add to Trajectories
         //Log() << Verbose(3) << step << ">=" << MDSteps-1 << endl;
@@ -555,6 +564,4 @@
   Vector Velocity;
   ForceMatrix Force;
-
-  CountElements();  // make sure ElementsInMolecule is up to date
 
   const int AtomCount = getAtomCount();
Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule_fragmentation.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -15,11 +20,14 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "lists.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
 #include "World.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
+#include "stackclass.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -448,5 +456,5 @@
       for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
     #ifdef ADDHYDROGEN
-        if ((*iter)->type->Z != 1) // skip hydrogen
+        if ((*iter)->getType()->Z != 1) // skip hydrogen
     #endif
         {
@@ -468,5 +476,5 @@
     for(molecule::const_iterator iter = begin(); iter != end(); ++iter) {
   #ifdef ADDHYDROGEN
-      if ((*iter)->type->Z != 1) // skip hydrogen
+      if ((*iter)->getType()->Z != 1) // skip hydrogen
   #endif
       {
@@ -877,5 +885,5 @@
   for (KeySet::iterator runner = Leaf->begin(); runner != Leaf->end(); runner++) {
     Runner = FindAtom((*runner));
-    if (Runner->type->Z != 1) { // skip all those added hydrogens when re-filling snake stack
+    if (Runner->getType()->Z != 1) { // skip all those added hydrogens when re-filling snake stack
       if (ShortestPathList[(*runner)] > SP) {  // remove the oldest one with longest shortest path
         SP = ShortestPathList[(*runner)];
@@ -966,5 +974,5 @@
     ++iter;
 #ifdef ADDHYDROGEN
-    while ((iter != Leaf->end()) && ((*iter)->type->Z == 1)){ // skip added hydrogen
+    while ((iter != Leaf->end()) && ((*iter)->getType()->Z == 1)){ // skip added hydrogen
       iter++;
     }
@@ -1344,5 +1352,5 @@
         if ((RestrictedKeySet.find(OtherWalker->nr) != RestrictedKeySet.end())
   #ifdef ADDHYDROGEN
-         && (OtherWalker->type->Z != 1)
+         && (OtherWalker->getType()->Z != 1)
   #endif
                                                               ) {  // skip hydrogens and restrict to fragment
@@ -1716,6 +1724,5 @@
   atom *Walker = NULL;
   atom *OtherWalker = NULL;
-  double * const cell_size = World::getInstance().getDomain();
-  double *matrix = ReturnFullMatrixforSymmetric(cell_size);
+  Matrix matrix = World::getInstance().getDomain().getM();
   enum Shading *ColorList = NULL;
   double tmp;
@@ -1739,5 +1746,5 @@
         Binder = (*BondRunner);
         for (int i=NDIM;i--;) {
-          tmp = fabs(Binder->leftatom->x[i] - Binder->rightatom->x[i]);
+          tmp = fabs(Binder->leftatom->at(i) - Binder->rightatom->at(i));
           //Log() << Verbose(3) << "Checking " << i << "th distance of " << *Binder->leftatom << " to " << *Binder->rightatom << ": " << tmp << "." << endl;
           if (tmp > BondDistance) {
@@ -1753,9 +1760,9 @@
       // create translation vector from their periodically modified distance
       for (int i=NDIM;i--;) {
-        tmp = Binder->leftatom->x[i] - Binder->rightatom->x[i];
+        tmp = Binder->leftatom->at(i) - Binder->rightatom->at(i);
         if (fabs(tmp) > BondDistance)
           Translationvector[i] = (tmp < 0) ? +1. : -1.;
       }
-      Translationvector.MatrixMultiplication(matrix);
+      Translationvector *= matrix;
       //Log() << Verbose(3) << "Translation vector is ";
       Log() << Verbose(0) << Translationvector <<  endl;
@@ -1768,5 +1775,5 @@
         //Log() << Verbose (3) << "Current Walker is: " << *Walker << "." << endl;
         ColorList[Walker->nr] = black;    // mark as explored
-        Walker->x += Translationvector; // translate
+        *Walker += Translationvector; // translate
         for (BondList::const_iterator Runner = Walker->ListOfBonds.begin(); Runner != Walker->ListOfBonds.end(); (++Runner)) {
           if ((*Runner) != Binder) {
@@ -1788,5 +1795,4 @@
   delete(AtomStack);
   delete[](ColorList);
-  delete[](matrix);
   DoLog(2) && (Log() << Verbose(2) << "End of ScanForPeriodicCorrection." << endl);
 };
Index: src/molecule_geometry.cpp
===================================================================
--- src/molecule_geometry.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule_geometry.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,5 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
+
+#include "Helpers/helpers.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Plane.hpp"
 
 #include "atom.hpp"
@@ -12,12 +24,14 @@
 #include "config.hpp"
 #include "element.hpp"
-#include "helpers.hpp"
 #include "leastsquaremin.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
-#include "Plane.hpp"
+
+#include "Box.hpp"
+
 #include <boost/foreach.hpp>
+
+#include <gsl/gsl_eigen.h>
+#include <gsl/gsl_multimin.h>
 
 
@@ -33,15 +47,13 @@
   const Vector *Center = DetermineCenterOfAll();
   const Vector *CenterBox = DetermineCenterOfBox();
-  double * const cell_size = World::getInstance().getDomain();
-  double *M = ReturnFullMatrixforSymmetric(cell_size);
-  double *Minv = InverseMatrix(M);
-
-  // go through all atoms
-  ActOnAllVectors( &Vector::SubtractVector, *Center);
-  ActOnAllVectors( &Vector::SubtractVector, *CenterBox);
-  ActOnAllVectors( &Vector::WrapPeriodically, (const double *)M, (const double *)Minv);
-
-  delete[](M);
-  delete[](Minv);
+  Box &domain = World::getInstance().getDomain();
+
+  // go through all atoms
+  BOOST_FOREACH(atom* iter, atoms){
+    *iter -= *Center;
+    *iter -= *CenterBox;
+  }
+  atoms.transformNodes(boost::bind(&Box::WrapPeriodically,domain,_1));
+
   delete(Center);
   delete(CenterBox);
@@ -56,13 +68,9 @@
 {
   bool status = true;
-  double * const cell_size = World::getInstance().getDomain();
-  double *M = ReturnFullMatrixforSymmetric(cell_size);
-  double *Minv = InverseMatrix(M);
-
-  // go through all atoms
-  ActOnAllVectors( &Vector::WrapPeriodically, (const double *)M, (const double *)Minv);
-
-  delete[](M);
-  delete[](Minv);
+  Box &domain = World::getInstance().getDomain();
+
+  // go through all atoms
+  atoms.transformNodes(boost::bind(&Box::WrapPeriodically,domain,_1));
+
   return status;
 };
@@ -80,12 +88,12 @@
   if (iter != end()) { //list not empty?
     for (int i=NDIM;i--;) {
-      max->at(i) = (*iter)->x[i];
-      min->at(i) = (*iter)->x[i];
+      max->at(i) = (*iter)->at(i);
+      min->at(i) = (*iter)->at(i);
     }
     for (; iter != end(); ++iter) {// continue with second if present
       //(*iter)->Output(1,1,out);
       for (int i=NDIM;i--;) {
-        max->at(i) = (max->at(i) < (*iter)->x[i]) ? (*iter)->x[i] : max->at(i);
-        min->at(i) = (min->at(i) > (*iter)->x[i]) ? (*iter)->x[i] : min->at(i);
+        max->at(i) = (max->at(i) < (*iter)->at(i)) ? (*iter)->at(i) : max->at(i);
+        min->at(i) = (min->at(i) > (*iter)->at(i)) ? (*iter)->at(i) : min->at(i);
       }
     }
@@ -98,5 +106,4 @@
     (*max) += (*min);
     Translate(min);
-    Center.Zero();
   }
   delete(min);
@@ -112,15 +119,14 @@
   int Num = 0;
   molecule::const_iterator iter = begin();  // start at first in list
+  Vector Center;
 
   Center.Zero();
-
   if (iter != end()) {   //list not empty?
     for (; iter != end(); ++iter) {  // continue with second if present
       Num++;
-      Center += (*iter)->x;
+      Center += (*iter)->getPosition();
     }
     Center.Scale(-1./(double)Num); // divide through total number (and sign for direction)
     Translate(&Center);
-    Center.Zero();
   }
 };
@@ -140,5 +146,5 @@
     for (; iter != end(); ++iter) {  // continue with second if present
       Num++;
-      (*a) += (*iter)->x;
+      (*a) += (*iter)->getPosition();
     }
     a->Scale(1./(double)Num); // divide through total mass (and sign for direction)
@@ -153,10 +159,6 @@
 {
   Vector *a = new Vector(0.5,0.5,0.5);
-
-  const double *cell_size = World::getInstance().getDomain();
-  double *M = ReturnFullMatrixforSymmetric(cell_size);
-  a->MatrixMultiplication(M);
-  delete[](M);
-
+  const Matrix &M = World::getInstance().getDomain().getM();
+  (*a) *= M;
   return a;
 };
@@ -166,5 +168,5 @@
  * \return pointer to center of gravity vector
  */
-Vector * molecule::DetermineCenterOfGravity()
+Vector * molecule::DetermineCenterOfGravity() const
 {
   molecule::const_iterator iter = begin();  // start at first in list
@@ -177,6 +179,6 @@
   if (iter != end()) {   //list not empty?
     for (; iter != end(); ++iter) {  // continue with second if present
-      Num += (*iter)->type->mass;
-      tmp = (*iter)->type->mass * (*iter)->x;
+      Num += (*iter)->getType()->mass;
+      tmp = (*iter)->getType()->mass * (*iter)->getPosition();
       (*a) += tmp;
     }
@@ -195,5 +197,10 @@
 void molecule::CenterPeriodic()
 {
-  DeterminePeriodicCenter(Center);
+  Vector NewCenter;
+  DeterminePeriodicCenter(NewCenter);
+  // go through all atoms
+  BOOST_FOREACH(atom* iter, atoms){
+    *iter -= NewCenter;
+  }
 };
 
@@ -205,5 +212,8 @@
 void molecule::CenterAtVector(Vector *newcenter)
 {
-  Center = *newcenter;
+  // go through all atoms
+  BOOST_FOREACH(atom* iter, atoms){
+    *iter -= *newcenter;
+  }
 };
 
@@ -222,5 +232,5 @@
     for (int j=0;j<MDSteps;j++)
       (*iter)->Trajectory.R.at(j).ScaleAll(*factor);
-    (*iter)->x.ScaleAll(*factor);
+    (*iter)->ScaleAll(*factor);
   }
 };
@@ -234,5 +244,5 @@
     for (int j=0;j<MDSteps;j++)
       (*iter)->Trajectory.R.at(j) += (*trans);
-    (*iter)->x += (*trans);
+    *(*iter) += (*trans);
   }
 };
@@ -244,14 +254,12 @@
 void molecule::TranslatePeriodically(const Vector *trans)
 {
-  double * const cell_size = World::getInstance().getDomain();
-  double *M = ReturnFullMatrixforSymmetric(cell_size);
-  double *Minv = InverseMatrix(M);
-
-  // go through all atoms
-  ActOnAllVectors( &Vector::AddVector, *trans);
-  ActOnAllVectors( &Vector::WrapPeriodically, (const double *)M, (const double *)Minv);
-
-  delete[](M);
-  delete[](Minv);
+  Box &domain = World::getInstance().getDomain();
+
+  // go through all atoms
+  BOOST_FOREACH(atom* iter, atoms){
+    *iter += *trans;
+  }
+  atoms.transformNodes(boost::bind(&Box::WrapPeriodically,domain,_1));
+
 };
 
@@ -264,7 +272,5 @@
   OBSERVE;
   Plane p(*n,0);
-  BOOST_FOREACH( atom* iter, atoms ){
-    (*iter->node) = p.mirrorVector(*iter->node);
-  }
+  atoms.transformNodes(boost::bind(&Plane::mirrorVector,p,_1));
 };
 
@@ -274,10 +280,10 @@
 void molecule::DeterminePeriodicCenter(Vector &center)
 {
-  double * const cell_size = World::getInstance().getDomain();
-  double *matrix = ReturnFullMatrixforSymmetric(cell_size);
-  double *inversematrix = InverseMatrix(matrix);
+  const Matrix &matrix = World::getInstance().getDomain().getM();
+  const Matrix &inversematrix = World::getInstance().getDomain().getM();
   double tmp;
   bool flag;
   Vector Testvector, Translationvector;
+  Vector Center;
 
   do {
@@ -286,13 +292,12 @@
     for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
 #ifdef ADDHYDROGEN
-      if ((*iter)->type->Z != 1) {
+      if ((*iter)->getType()->Z != 1) {
 #endif
-        Testvector = (*iter)->x;
-        Testvector.MatrixMultiplication(inversematrix);
+        Testvector = inversematrix * (*iter)->getPosition();
         Translationvector.Zero();
         for (BondList::const_iterator Runner = (*iter)->ListOfBonds.begin(); Runner != (*iter)->ListOfBonds.end(); (++Runner)) {
          if ((*iter)->nr < (*Runner)->GetOtherAtom((*iter))->nr) // otherwise we shift one to, the other fro and gain nothing
             for (int j=0;j<NDIM;j++) {
-              tmp = (*iter)->x[j] - (*Runner)->GetOtherAtom(*iter)->x[j];
+              tmp = (*iter)->at(j) - (*Runner)->GetOtherAtom(*iter)->at(j);
               if ((fabs(tmp)) > BondDistance) {
                 flag = false;
@@ -306,5 +311,5 @@
         }
         Testvector += Translationvector;
-        Testvector.MatrixMultiplication(matrix);
+        Testvector *= matrix;
         Center += Testvector;
         Log() << Verbose(1) << "vector is: " << Testvector << endl;
@@ -312,9 +317,8 @@
         // now also change all hydrogens
         for (BondList::const_iterator Runner = (*iter)->ListOfBonds.begin(); Runner != (*iter)->ListOfBonds.end(); (++Runner)) {
-          if ((*Runner)->GetOtherAtom((*iter))->type->Z == 1) {
-            Testvector = (*Runner)->GetOtherAtom((*iter))->x;
-            Testvector.MatrixMultiplication(inversematrix);
+          if ((*Runner)->GetOtherAtom((*iter))->getType()->Z == 1) {
+            Testvector = inversematrix * (*Runner)->GetOtherAtom((*iter))->getPosition();
             Testvector += Translationvector;
-            Testvector.MatrixMultiplication(matrix);
+            Testvector *= matrix;
             Center += Testvector;
             Log() << Verbose(1) << "Hydrogen vector is: " << Testvector << endl;
@@ -325,104 +329,8 @@
     }
   } while (!flag);
-  delete[](matrix);
-  delete[](inversematrix);
 
   Center.Scale(1./static_cast<double>(getAtomCount()));
-};
-
-/** Transforms/Rotates the given molecule into its principal axis system.
- * \param *out output stream for debugging
- * \param DoRotate whether to rotate (true) or only to determine the PAS.
- * TODO treatment of trajetories missing
- */
-void molecule::PrincipalAxisSystem(bool DoRotate)
-{
-  double InertiaTensor[NDIM*NDIM];
-  Vector *CenterOfGravity = DetermineCenterOfGravity();
-
-  CenterPeriodic();
-
-  // reset inertia tensor
-  for(int i=0;i<NDIM*NDIM;i++)
-    InertiaTensor[i] = 0.;
-
-  // sum up inertia tensor
-  for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
-    Vector x = (*iter)->x;
-    //x.SubtractVector(CenterOfGravity);
-    InertiaTensor[0] += (*iter)->type->mass*(x[1]*x[1] + x[2]*x[2]);
-    InertiaTensor[1] += (*iter)->type->mass*(-x[0]*x[1]);
-    InertiaTensor[2] += (*iter)->type->mass*(-x[0]*x[2]);
-    InertiaTensor[3] += (*iter)->type->mass*(-x[1]*x[0]);
-    InertiaTensor[4] += (*iter)->type->mass*(x[0]*x[0] + x[2]*x[2]);
-    InertiaTensor[5] += (*iter)->type->mass*(-x[1]*x[2]);
-    InertiaTensor[6] += (*iter)->type->mass*(-x[2]*x[0]);
-    InertiaTensor[7] += (*iter)->type->mass*(-x[2]*x[1]);
-    InertiaTensor[8] += (*iter)->type->mass*(x[0]*x[0] + x[1]*x[1]);
-  }
-  // print InertiaTensor for debugging
-  DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
-  for(int i=0;i<NDIM;i++) {
-    for(int j=0;j<NDIM;j++)
-      DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
-    DoLog(0) && (Log() << Verbose(0) << endl);
-  }
-  DoLog(0) && (Log() << Verbose(0) << endl);
-
-  // diagonalize to determine principal axis system
-  gsl_eigen_symmv_workspace *T = gsl_eigen_symmv_alloc(NDIM);
-  gsl_matrix_view m = gsl_matrix_view_array(InertiaTensor, NDIM, NDIM);
-  gsl_vector *eval = gsl_vector_alloc(NDIM);
-  gsl_matrix *evec = gsl_matrix_alloc(NDIM, NDIM);
-  gsl_eigen_symmv(&m.matrix, eval, evec, T);
-  gsl_eigen_symmv_free(T);
-  gsl_eigen_symmv_sort(eval, evec, GSL_EIGEN_SORT_ABS_DESC);
-
-  for(int i=0;i<NDIM;i++) {
-    DoLog(1) && (Log() << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i));
-    DoLog(0) && (Log() << Verbose(0) << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl);
-  }
-
-  // check whether we rotate or not
-  if (DoRotate) {
-    DoLog(1) && (Log() << Verbose(1) << "Transforming molecule into PAS ... ");
-    // the eigenvectors specify the transformation matrix
-    ActOnAllVectors( &Vector::MatrixMultiplication, (const double *) evec->data );
-    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
-
-    // summing anew for debugging (resulting matrix has to be diagonal!)
-    // reset inertia tensor
-    for(int i=0;i<NDIM*NDIM;i++)
-      InertiaTensor[i] = 0.;
-
-    // sum up inertia tensor
-    for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
-      Vector x = (*iter)->x;
-      InertiaTensor[0] += (*iter)->type->mass*(x[1]*x[1] + x[2]*x[2]);
-      InertiaTensor[1] += (*iter)->type->mass*(-x[0]*x[1]);
-      InertiaTensor[2] += (*iter)->type->mass*(-x[0]*x[2]);
-      InertiaTensor[3] += (*iter)->type->mass*(-x[1]*x[0]);
-      InertiaTensor[4] += (*iter)->type->mass*(x[0]*x[0] + x[2]*x[2]);
-      InertiaTensor[5] += (*iter)->type->mass*(-x[1]*x[2]);
-      InertiaTensor[6] += (*iter)->type->mass*(-x[2]*x[0]);
-      InertiaTensor[7] += (*iter)->type->mass*(-x[2]*x[1]);
-      InertiaTensor[8] += (*iter)->type->mass*(x[0]*x[0] + x[1]*x[1]);
-    }
-    // print InertiaTensor for debugging
-    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
-    for(int i=0;i<NDIM;i++) {
-      for(int j=0;j<NDIM;j++)
-        DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
-      DoLog(0) && (Log() << Verbose(0) << endl);
-    }
-    DoLog(0) && (Log() << Verbose(0) << endl);
-  }
-
-  // free everything
-  delete(CenterOfGravity);
-  gsl_vector_free(eval);
-  gsl_matrix_free(evec);
-};
-
+  CenterAtVector(&Center);
+};
 
 /** Align all atoms in such a manner that given vector \a *n is along z axis.
@@ -442,7 +350,7 @@
   DoLog(1) && (Log() << Verbose(1) << "Z-X-angle: " << alpha << " ... ");
   for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
-    tmp = (*iter)->x[0];
-    (*iter)->x[0] =  cos(alpha) * tmp + sin(alpha) * (*iter)->x[2];
-    (*iter)->x[2] = -sin(alpha) * tmp + cos(alpha) * (*iter)->x[2];
+    tmp = (*iter)->at(0);
+    (*iter)->set(0,  cos(alpha) * tmp + sin(alpha) * (*iter)->at(2));
+    (*iter)->set(2, -sin(alpha) * tmp + cos(alpha) * (*iter)->at(2));
     for (int j=0;j<MDSteps;j++) {
       tmp = (*iter)->Trajectory.R.at(j)[0];
@@ -461,7 +369,7 @@
   DoLog(1) && (Log() << Verbose(1) << "Z-Y-angle: " << alpha << " ... ");
   for (molecule::const_iterator iter = begin(); iter != end(); ++iter) {
-    tmp = (*iter)->x[1];
-    (*iter)->x[1] =  cos(alpha) * tmp + sin(alpha) * (*iter)->x[2];
-    (*iter)->x[2] = -sin(alpha) * tmp + cos(alpha) * (*iter)->x[2];
+    tmp = (*iter)->at(1);
+    (*iter)->set(1,  cos(alpha) * tmp + sin(alpha) * (*iter)->at(2));
+    (*iter)->set(2, -sin(alpha) * tmp + cos(alpha) * (*iter)->at(2));
     for (int j=0;j<MDSteps;j++) {
       tmp = (*iter)->Trajectory.R.at(j)[1];
@@ -501,6 +409,6 @@
   // go through all atoms
   for (molecule::const_iterator iter = par->mol->begin(); iter != par->mol->end(); ++iter) {
-    if ((*iter)->type == ((struct lsq_params *)params)->type) { // for specific type
-      c = (*iter)->x - a;
+    if ((*iter)->getType() == ((struct lsq_params *)params)->type) { // for specific type
+      c = (*iter)->getPosition() - a;
       t = c.ScalarProduct(b);           // get direction parameter
       d = t*b;       // and create vector
Index: src/molecule_graph.cpp
===================================================================
--- src/molecule_graph.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule_graph.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -14,15 +19,17 @@
 #include "defs.hpp"
 #include "element.hpp"
-#include "helpers.hpp"
-#include "info.hpp"
+#include "Helpers/helpers.hpp"
+#include "Helpers/Info.hpp"
 #include "linkedcell.hpp"
 #include "lists.hpp"
-#include "log.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
 #include "World.hpp"
 #include "Helpers/fast_functions.hpp"
 #include "Helpers/Assert.hpp"
-
+#include "LinearAlgebra/Matrix.hpp"
+#include "Box.hpp"
+#include "stackclass.hpp"
 
 struct BFSAccounting
@@ -121,5 +128,5 @@
   LinkedCell *LC = NULL;
   bool free_BG = false;
-  double * const cell_size = World::getInstance().getDomain();
+  Box &domain = World::getInstance().getDomain();
 
   if (BG == NULL) {
@@ -178,5 +185,5 @@
                           //Log() << Verbose(1) << "Checking distance " << OtherWalker->x.PeriodicDistanceSquared(&(Walker->x), cell_size) << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
                           (BG->*minmaxdistance)(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
-                          const double distance = OtherWalker->x.PeriodicDistanceSquared(Walker->x,cell_size);
+                          const double distance = domain.periodicDistanceSquared(OtherWalker->getPosition(),Walker->getPosition());
                           const bool status = (distance <= MaxDistance * MaxDistance) && (distance >= MinDistance * MinDistance);
 //                          Log() << Verbose(1) << "MinDistance is " << MinDistance << " and MaxDistance is " << MaxDistance << "." << endl;
@@ -579,5 +586,5 @@
     // From OldGraphNr to CurrentGraphNr ranges an disconnected subgraph
     DoLog(0) && (Log() << Verbose(0) << "Disconnected subgraph ranges from " << OldGraphNr << " to " << DFS.CurrentGraphNr << "." << endl);
-    LeafWalker->Leaf->Output((ofstream *)&cout);
+    LeafWalker->Leaf->Output((ofstream *)&(Log() << Verbose(0)));
     DoLog(0) && (Log() << Verbose(0) << endl);
 
@@ -731,5 +738,5 @@
         OtherAtom = (*Runner)->GetOtherAtom(Walker);
 #ifdef ADDHYDROGEN
-        if (OtherAtom->type->Z != 1) {
+        if (OtherAtom->getType()->Z != 1) {
 #endif
         DoLog(2) && (Log() << Verbose(2) << "Current OtherAtom is: " << OtherAtom->getName() << " for bond " << *(*Runner) << "." << endl);
Index: src/molecule_pointcloud.cpp
===================================================================
--- src/molecule_pointcloud.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/molecule_pointcloud.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,10 +6,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "atom.hpp"
 #include "config.hpp"
-#include "info.hpp"
-#include "memoryallocator.hpp"
+#include "Helpers/Info.hpp"
 #include "molecule.hpp"
 
